Index: src/uk/me/parabola/imgfmt/app/net/RouteArc.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/net/RouteArc.java	(revision 4561)
+++ src/uk/me/parabola/imgfmt/app/net/RouteArc.java	(working copy)
@@ -104,7 +104,6 @@
 			log.error("Way " + roadDef.getName() + " (id " + roadDef.getId() + ") contains an arc whose length (" + len + " units) is too big to be encoded, using length",((1 << 22) - 1));
 			len = (1 << 22) - 1;
 		}
-		this.length = len;
 		this.lengthInMeter = (float) arcLength;
 		this.pointsHash = pointsHash;
 		// calculate length ratio between way length on road and direct distance between end points
@@ -117,7 +116,11 @@
 			}
 		}
 		if (ratio == 0 && len >= (1 << 14))
-			ratio = 0x1f; // force encoding of curve info for very long arcs
+			ratio = 31; // force encoding of curve info for very long arcs
+		if (ratio == 0 && len < 7 && arcLength == pathLength) {
+			len=7; 
+		}
+		this.length = len;
 		lengthRatio = (byte)ratio;
 		haveCurve = lengthRatio > 0;
 	}
